#include"num.h"

void num::fromByteArray(byte* a, int & where) {
	int w;
	for(w = 0; w < MAX; w++){
		byte b = a[where];
		where++;
		value[w] = b;
		if(!(b & 0x80))
			break;
	}

	used = w;
}

void num::fromByteArray(QByteArray & b, int & where) {
	fromByteArray((byte*)b.data(), where);
}

void num::toByteArray(QByteArray & b, int & where) {
	toByteArray((byte*)b.data(), where);
}

void num::toByteArray(byte* a, int & where) {
	for(int c = 0; c < used; c++)
		a[where++] = value[c];
}

int num::toInt() {
	int sum = 0;

	for(int w = 0; w < MAX /* used */; w++) {
		int v = value[w] & 0x7f;

		v <<= (7 * w);
		sum |= v;

		if(!(value[w] & 0x80))
			break;
	}

	return sum;
}

void num::fromInt(int n) {
	int val = n;
	int w = 0;

	bool more = true;
	while(more) {
		byte v = val & 0x7f;
		val >>= 7;
		more = (val != 0);

		if(more)
			v |= 0x80;

		value[w] = v;
		w++;
	}

	used = w;
}


