server:
	void sendMessage(int toWhom, string message);
	int getUserId(string who);
	string getUserName(int id);

	void goAway(string message);
	void comeBack();

	void becomeIdle();
	void becomeActive();

	int createChat(string name);

client:
	void postMessage(int fromWhom, string message);
	string user, string password getAuthenticationData();
	void authenticationChange(int newId);


	int requestAuthorization(int fromWhom, int type);
/*

user adr
	factories: im [p], triple-triad [p], chess [p], rotate-13 [m]
	channels: chat, rotate-13-a


		For most factories, it sends auth first, then actually creates it and goes nuts.

	Under factories, the p means private and the m means multiple.
	P ones just open up a one on one chat.
	M ones open a new channel which someone else can join.



CHAT SUBSYSTEM

	People


	Private message
		Only to real accounts; plain old IM.
	Chat rooms
		Chat rooms are pseudo accounts or real accounts.
		You can open a chat room to a person.

		Note to clients: being in a chat room shouldn't be the same as leaving the window open.

	Communication channels
		Owned by people
		Have access control lists
		Every person gets one automatically that is a private factory (plain old one on one chat)

		Slight notification: typing


		Channel types:
			Public
			Private
			Factory
				Sending a message to a factory will reply with the id of a newly created channel.

	Topics
		Topics let you thread off the talking in a single channel. You can't tree off though - topics can't have
		child topics.

PRESENCE SUBSYSTEM

	People
		Has access control lists
		Has a notification push list

		Elements: info, away, idle


*/
