public import base;
public import controls;
public import windows;

/// Displays a simple message box with an OK button and the given title and message.
void messageBox(string title, string message, Display d = null) {
	Display display;
	if(d is null)
		display = Display.newestDisplay;
	else
		display = d;
	assert(display !is null);

	display.messageBox(title, message);
}
import std.stdio;
/// Fills in the variables provided by presenting a dialog box to the user. It determines the widgets to use based on the variable's types
template FormDialog(alias T, alias R){
	/// return true on OK, false on cancel
	bool FormDialog(string title, Display d = null) {
		Display display;
		if(d is null)
			display = Display.newestDisplay;
		else
			display = d;
		assert(display !is null);

		bool waiting = true;
		bool canceled = false;

		auto w = new MainWindow;
		w.title = title;

		auto n1 = new Label(T.stringof, w);
			n1.setGeometry(0, 0, 1, 1);
		auto n = new LineEdit(w);
			n.setGeometry(1, 0, 2, 1);

		auto p1 = new Label(R.stringof, w);
			p1.setGeometry(0, 1, 1, 1);
		auto p = new LineEdit(w);
		p.setGeometry(1, 1, 2, 1);
		auto o = new PushButton("OK", w, {
		writefln("OK");
			T = n.text;
			R = p.text;
			waiting = false;
		});
		o.setGeometry(1, 2, 1, 1);
		auto c = new PushButton("Cancel", w, {
			canceled = true;
			waiting = false;
		});
		c.setGeometry(2, 2, 1, 1);

		w.show;

		writefln("here");

		while(waiting) {
			writefln("blocking");
			if(!DWSApp.singleton.el.proceed())
				throw new Exception("Proceed");
			display.resetRead; // FIXME surely a bug
		}

		w.close;

		return !canceled;
	}
}


