typedef unsigned char byte;

class Buffer {
public:
	byte operator[] (int a) {
		return data[a];
	}

	int length() {
		return len;
	}

	Buffer() { len = 1024;}

	byte data[1024];
	int len;
};

#define MAX 8
struct num {
	/// Where should be pointing at the beginning of it. When we're done, we'll be pointing right after it.
	void fromByteArray(byte* a, int & where) {
		int w;
		for(w = 0; w < MAX; w++){
			byte b = a[where];
			where++;
			value[w] = b;
			if(!(b & 0x80))
				break;
		}

		used = w;
	}

	void fromByteArray(Buffer & b, int & where) {
		fromByteArray(b.data, where);
	}

	void toByteArray(Buffer & b, int & where) {
		toByteArray(b.data, where);
	}

	void toByteArray(byte* a, int & where) {
		for(int c = 0; c < used; c++)
			a[where++] = value[c];
	}

	int toInt() {
		int sum = 0;

		for(int w = 0; w < MAX /* used */; w++) {
			int v = value[w] & 0x7f;

			v <<= (7 * w);
			sum |= v;

			if(!(value[w] & 0x80))
				break;
		}

		return sum;
	}

	void fromInt(int n) {
		int val = n;
		int w = 0;

		bool more = true;
		while(more) {
			byte v = val & 0x7f;
			val >>= 7;
			more = (val != 0);

			if(more)
				v |= 0x80;

			value[w] = v;
			w++;
		}

		used = w;
	}


	int used;
	byte value[MAX];
};


#include<QString>
#include<QByteArray>

QByteArray qba;



void write(Buffer &b, int s, int e) { }
void write(byte* b, int s, int e) { }
