interface Web {
	// Output functions
	void setCookie(string name, string value);
	void redirect(string where);
	void output(string type, const(byte)[] data);

	// Input functions
	string requestMethod();
	string getVar(string name, string def = null); // gets GET and POST data
	string getCookie(string name, string def = null); // default is val to return if variable not present, if null, it throws an exception
	string remoteAddr();
	string userAgent();
	string pathInfo();
	string scriptName();

	// Convenience functions
	bool isLocalhost();
	bool isPost();
}
