import arsd.netman;
import std.stdio;

import generated2;

IMConnection conn;

class IMConnection : GeneratedConnection {
	override void onConnect() {
		conn = this;
	}

	override void onDisconnect() {
		throw new Exception("connection lost " ~ reason);
	}

	override void getAuthenticationData(out string user, out string pass) {
		user = username;
		pass = password;
	}
}

class Stdin : Connection {
	override void onDataReceived() {
		if(conn && conn.ready)
			conn.sendMessage(1, cast(string) read());
		else
			writefln("rejected");
		resetRead();
	}

}


string username, password;

void main(string[] args) {

	username = args[1];

	MyMan netman = new MyMan;

	netman.connect("localhost",8080);
	netman.openStdin();
	while( netman.proceed( ) ) { }
}

class MyMan : NetworkManager {
	override Connection allocConnection(int port) {
		if(port == 0)
			return new Stdin();
		else {
			auto c = new IMConnection();
			return c;
		}
	}
}


