import std.string;
import std.stdio;

import arsd.netman;
/*
void main() {
	auto netman = new LOL;
	netman.connect("toc.oscar.aol.com", 9898);

	while(netman.proceed) { }
}


class LOL : NetworkManager { 
	override Connection allocConnection(int port) {
		return new AimConnection;
	}
}
*/

interface AimClient {
	void gotMessage(string fromWhom, bool automatic, string message);

	void setConnection(AimConnection c);
}


class AimConnection : Connection {
	immutable int SIGNON = 1;
	immutable int DATA = 2;

	int state;

	AimClient client;
	string username;
	string password;
	this(string u, string p, AimClient c) {
		username = u;
		password = p;
		client = c;
		client.setConnection(this);
	}


	override void onConnect() {
		write(cast(const(byte)[]) "FLAPON\r\n\r\n");
		state = 0;
	}

	override void onDisconnect() {
		throw new Exception("error");
	}

	short sequence = 0;

	void sendFlap(int type, string str) {
		int length = str.length + 1;
		sequence++;

		byte[] data;
		data.length = length + 6;

		data[0] = '*';
		data[1] = cast(byte) type;
		data[2] = (sequence >> 8) & 0xff;
		data[3] = sequence & 0xff;
		data[4] = (length >> 8) & 0xff;
		data[5] = length & 0xff;
		data[6..$-1] = cast(byte[]) str[0..$];
		data[$-1] = 0;

		write(data);
	}

	string getFlap(const(byte)[] data, inout int position) {
		writefln("%d out of %d", position, data.length);
		assert(data[position] == '*');
		position += 4;

		int len;
		len = data[position++] << 8;
		len |= data[position++];

		string str = cast(string) (data[position..position+len].idup);
		position += len;
		return str;
	}

	override void write(const(byte)[] data) {
		writefln("writing: %s", cast(string) data);
		super.write(data);
	}

	override void onDataReceived() {
		const(byte)[] data = read();

			writefln("state: %d", state);
			writefln("%s", cast(string) data);

		int where = 0;

		switch(state) {
		case 0:
			getFlap(data, where);

			int len = username.length + 8;
			sequence++;
			byte[] writing;
			writing.length = len + 6;
			writing[0] = '*';
			writing[1] = SIGNON;
			writing[2] = (sequence >> 8) & 0xff;
			writing[3] = sequence & 0xff;
			writing[4] = (len >> 8) & 0xff;
			writing[5] = len & 0xff;
			writing[6] = 0;
			writing[7] = 0;
			writing[8] = 0;
			writing[9] = 1;
			writing[10] = 0;
			writing[11] = 1;
			writing[12] = (username.length >> 8) & 0xff;
			writing[13] = username.length & 0xff;
			writing[14..14+username.length] = cast(byte[]) (username[0..$].dup);

			write(writing);
			state++;
		//break;
		case 1:

			int calculatecode() {
				int q = username[0] - 96;
				int w = password[0] - 96;
				int a = q * 7696 + 738816;
				int b = q * 746512;
				int c = w * a;
				return (c - a + b + 71665152);
			}

			string lolpassword() {
				const(byte)[] xor = cast(const(byte)[]) "Tic/Toc";
				int i = 0;

				string r = "0x";

				for(int a = 0; a < password.length; a++) {
					string h = format("%02x", xor[i] ^ password[a]);
					r ~= h;
					i ++;
					if(i == xor.length)
						i = 0;
				}
				return r;
			}

			string cmd = format("toc2_signon %s %d %s %s %s \"%s\" 160 %d",
				"login.oscar.aol.com", 5190,
				username,
				lolpassword,
				"english",
				"TIC:lol", // can be whatever
				calculatecode
				);

			sendFlap(DATA, cmd);
			state++;
		break;
		case 2:
			getFlap(data, where);
			// check for error

			sendFlap(DATA, format("toc_add_buddy %s", username));
			sendFlap(DATA, "toc_init_done");
//			sendFlap(DATA,"toc_set_caps 09461343-4C7F-11D1-8222-444553540000 09461348-4C7F-11D1-8222-444553540000"); // I dunno what that means
			sendFlap(DATA, "toc_add_permit ");
			sendFlap(DATA, "toc_add_deny ");

			state++;
		break;
		case 3:
			string d = getFlap(data, where);
			int np = 0;
			string command = nextChunk(d, np);
			// here we parse the strings coming in for normal operation
			switch(command) {
				case "IM_IN2":
					string fromWhom = nextChunk(d, np);
					bool isAutomatic = nextChunk(d, np) == "T";
					string wtf = nextChunk(d, np);
					string message = d[np..$];

					client.gotMessage(fromWhom, isAutomatic, message);
				break;
				default:
					// FIXME: ignoring unknown messages
			}

		break;
		}

		resetRead();
	}


	string normalize(string screenname) {
		return tolower(removechars(screenname, " "));
	}

	string nextChunk(string data, inout int pos) {
		int p = indexOf(data[pos..$], ':');
		if(p == -1) {
			string d = data[pos..$];
			pos = data.length;
			return d;
		} else {
			string d = data[pos..(pos+p)];
			pos += p + 1;
			return d;
		}
	}

	string encode(string message) {
		message = replace(message, `\`, r"\\");
		message = replace(message, `{`, `\{`);
		message = replace(message, `}`, `\}`);
		message = replace(message, `"`, `\"`);
		message = replace(message, "\n", `<br>`);
		return message;
	}

	void sendIm(string toWhom, string message) {
		sendFlap(DATA, format("toc_send_im %s \"%s\"", normalize(toWhom), encode(message)));
	}

}

/*
interface ImProtocol {
	void sendIm(string toWhom, string message);
	void handleIm(string fromWhom, string message);
}
*/
/*
	The functions we care about:
		send/receive IM
		chat
		buddy list updates
		changing buddy list
		get/set info
		idle
		away
		get/send typing notifications

*/
